/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Subtarget Enumeration Source Fragment                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#ifdef GET_SUBTARGETINFO_ENUM
#undef GET_SUBTARGETINFO_ENUM

namespace llvm {
namespace AVR {
enum {
  ELFArchAVR1 = 0,
  ELFArchAVR2 = 1,
  ELFArchAVR3 = 2,
  ELFArchAVR4 = 3,
  ELFArchAVR5 = 4,
  ELFArchAVR6 = 5,
  ELFArchAVR25 = 6,
  ELFArchAVR31 = 7,
  ELFArchAVR35 = 8,
  ELFArchAVR51 = 9,
  ELFArchTiny = 10,
  ELFArchXMEGA1 = 11,
  ELFArchXMEGA2 = 12,
  ELFArchXMEGA3 = 13,
  ELFArchXMEGA4 = 14,
  ELFArchXMEGA5 = 15,
  ELFArchXMEGA6 = 16,
  ELFArchXMEGA7 = 17,
  FamilyAVR0 = 18,
  FamilyAVR1 = 19,
  FamilyAVR2 = 20,
  FamilyAVR3 = 21,
  FamilyAVR4 = 22,
  FamilyAVR5 = 23,
  FamilyAVR6 = 24,
  FamilyAVR25 = 25,
  FamilyAVR31 = 26,
  FamilyAVR35 = 27,
  FamilyAVR51 = 28,
  FamilyTiny = 29,
  FamilyXMEGA = 30,
  FamilyXMEGAU = 31,
  FeatureADDSUBIW = 32,
  FeatureBREAK = 33,
  FeatureDES = 34,
  FeatureEIJMPCALL = 35,
  FeatureELPM = 36,
  FeatureELPMX = 37,
  FeatureIJMPCALL = 38,
  FeatureJMPCALL = 39,
  FeatureLPM = 40,
  FeatureLPMX = 41,
  FeatureMOVW = 42,
  FeatureMultiplication = 43,
  FeatureRMW = 44,
  FeatureSPM = 45,
  FeatureSPMX = 46,
  FeatureSRAM = 47,
  FeatureSetSpecial = 48,
  FeatureSmallStack = 49,
  FeatureTinyEncoding = 50,
};
} // end namespace AVR
} // end namespace llvm

#endif // GET_SUBTARGETINFO_ENUM


#ifdef GET_SUBTARGETINFO_MC_DESC
#undef GET_SUBTARGETINFO_MC_DESC

namespace llvm {
// Sorted (by key) array of values for CPU features.
extern const llvm::SubtargetFeatureKV AVRFeatureKV[] = {
  { "addsubiw", "Enable 16-bit register-immediate addition and subtraction instructions", { AVR::FeatureADDSUBIW }, { } },
  { "avr0", "The device is a part of the avr0 family", { AVR::FamilyAVR0 }, { } },
  { "avr1", "The device is a part of the avr1 family", { AVR::FamilyAVR1 }, { AVR::FamilyAVR0, AVR::FeatureLPM } },
  { "avr2", "The device is a part of the avr2 family", { AVR::FamilyAVR2 }, { AVR::FamilyAVR1, AVR::FeatureIJMPCALL, AVR::FeatureADDSUBIW, AVR::FeatureSRAM } },
  { "avr25", "The device is a part of the avr25 family", { AVR::FamilyAVR25 }, { AVR::FamilyAVR2, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM, AVR::FeatureBREAK } },
  { "avr3", "The device is a part of the avr3 family", { AVR::FamilyAVR3 }, { AVR::FamilyAVR2, AVR::FeatureJMPCALL } },
  { "avr31", "The device is a part of the avr31 family", { AVR::FamilyAVR31 }, { AVR::FamilyAVR3, AVR::FeatureELPM } },
  { "avr35", "The device is a part of the avr35 family", { AVR::FamilyAVR35 }, { AVR::FamilyAVR3, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM, AVR::FeatureBREAK } },
  { "avr4", "The device is a part of the avr4 family", { AVR::FamilyAVR4 }, { AVR::FamilyAVR2, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM, AVR::FeatureBREAK } },
  { "avr5", "The device is a part of the avr5 family", { AVR::FamilyAVR5 }, { AVR::FamilyAVR3, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM, AVR::FeatureBREAK } },
  { "avr51", "The device is a part of the avr51 family", { AVR::FamilyAVR51 }, { AVR::FamilyAVR5, AVR::FeatureELPM, AVR::FeatureELPMX } },
  { "avr6", "The device is a part of the avr6 family", { AVR::FamilyAVR6 }, { AVR::FamilyAVR51 } },
  { "avrtiny", "The device is a part of the avrtiny family", { AVR::FamilyTiny }, { AVR::FamilyAVR0, AVR::FeatureBREAK, AVR::FeatureSRAM, AVR::FeatureTinyEncoding } },
  { "break", "The device supports the `BREAK` debugging instruction", { AVR::FeatureBREAK }, { } },
  { "des", "The device supports the `DES k` encryption instruction", { AVR::FeatureDES }, { } },
  { "eijmpcall", "The device supports the `EIJMP`/`EICALL` instructions", { AVR::FeatureEIJMPCALL }, { } },
  { "elpm", "The device supports the ELPM instruction", { AVR::FeatureELPM }, { } },
  { "elpmx", "The device supports the `ELPM Rd, Z[+]` instructions", { AVR::FeatureELPMX }, { } },
  { "ijmpcall", "The device supports `IJMP`/`ICALL`instructions", { AVR::FeatureIJMPCALL }, { } },
  { "jmpcall", "The device supports the `JMP` and `CALL` instructions", { AVR::FeatureJMPCALL }, { } },
  { "lpm", "The device supports the `LPM` instruction", { AVR::FeatureLPM }, { } },
  { "lpmx", "The device supports the `LPM Rd, Z[+]` instruction", { AVR::FeatureLPMX }, { } },
  { "movw", "The device supports the 16-bit MOVW instruction", { AVR::FeatureMOVW }, { } },
  { "mul", "The device supports the multiplication instructions", { AVR::FeatureMultiplication }, { } },
  { "rmw", "The device supports the read-write-modify instructions: XCH, LAS, LAC, LAT", { AVR::FeatureRMW }, { } },
  { "smallstack", "The device has an 8-bit stack pointer", { AVR::FeatureSmallStack }, { } },
  { "special", "Enable use of the entire instruction set - used for debugging", { AVR::FeatureSetSpecial }, { AVR::FeatureSRAM, AVR::FeatureJMPCALL, AVR::FeatureIJMPCALL, AVR::FeatureEIJMPCALL, AVR::FeatureADDSUBIW, AVR::FeatureMOVW, AVR::FeatureLPM, AVR::FeatureLPMX, AVR::FeatureELPM, AVR::FeatureELPMX, AVR::FeatureSPM, AVR::FeatureSPMX, AVR::FeatureDES, AVR::FeatureRMW, AVR::FeatureMultiplication, AVR::FeatureBREAK } },
  { "spm", "The device supports the `SPM` instruction", { AVR::FeatureSPM }, { } },
  { "spmx", "The device supports the `SPM Z+` instruction", { AVR::FeatureSPMX }, { } },
  { "sram", "The device has random access memory", { AVR::FeatureSRAM }, { } },
  { "tinyencoding", "The device has Tiny core specific instruction encodings", { AVR::FeatureTinyEncoding }, { } },
  { "xmega", "The device is a part of the xmega family", { AVR::FamilyXMEGA }, { AVR::FamilyAVR51, AVR::FeatureEIJMPCALL, AVR::FeatureSPMX, AVR::FeatureDES } },
  { "xmegau", "The device is a part of the xmegau family", { AVR::FamilyXMEGAU }, { AVR::FamilyXMEGA, AVR::FeatureRMW } },
};

// Sorted (by key) array of values for CPU subtype.
extern const llvm::SubtargetFeatureKV AVRSubTypeKV[] = {
  { "at43usb320", "Select the at43usb320 processor", { AVR::FamilyAVR31, AVR::ELFArchAVR31 }, { } },
  { "at43usb355", "Select the at43usb355 processor", { AVR::FamilyAVR3, AVR::ELFArchAVR3 }, { } },
  { "at76c711", "Select the at76c711 processor", { AVR::FamilyAVR3, AVR::ELFArchAVR3 }, { } },
  { "at86rf401", "Select the at86rf401 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR25, AVR::FeatureMOVW, AVR::FeatureLPMX }, { } },
  { "at90c8534", "Select the at90c8534 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90can128", "Select the at90can128 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "at90can32", "Select the at90can32 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90can64", "Select the at90can64 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90pwm1", "Select the at90pwm1 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "at90pwm161", "Select the at90pwm161 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90pwm2", "Select the at90pwm2 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "at90pwm216", "Select the at90pwm216 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90pwm2b", "Select the at90pwm2b processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "at90pwm3", "Select the at90pwm3 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "at90pwm316", "Select the at90pwm316 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90pwm3b", "Select the at90pwm3b processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "at90pwm81", "Select the at90pwm81 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "at90s1200", "Select the at90s1200 processor", { AVR::FamilyAVR0, AVR::ELFArchAVR1 }, { } },
  { "at90s2313", "Select the at90s2313 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s2323", "Select the at90s2323 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s2333", "Select the at90s2333 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s2343", "Select the at90s2343 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s4414", "Select the at90s4414 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s4433", "Select the at90s4433 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s4434", "Select the at90s4434 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s8515", "Select the at90s8515 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90s8535", "Select the at90s8535 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "at90scr100", "Select the at90scr100 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90usb1286", "Select the at90usb1286 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "at90usb1287", "Select the at90usb1287 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "at90usb162", "Select the at90usb162 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "at90usb646", "Select the at90usb646 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90usb647", "Select the at90usb647 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "at90usb82", "Select the at90usb82 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "at94k", "Select the at94k processor", { AVR::FamilyAVR3, AVR::ELFArchAVR5, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX }, { } },
  { "ata5272", "Select the ata5272 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "ata5505", "Select the ata5505 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "ata5790", "Select the ata5790 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "ata5795", "Select the ata5795 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "ata6285", "Select the ata6285 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "ata6286", "Select the ata6286 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "ata6289", "Select the ata6289 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega103", "Select the atmega103 processor", { AVR::FamilyAVR31, AVR::ELFArchAVR31 }, { } },
  { "atmega128", "Select the atmega128 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega1280", "Select the atmega1280 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega1281", "Select the atmega1281 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega1284", "Select the atmega1284 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega1284p", "Select the atmega1284p processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega1284rfr2", "Select the atmega1284rfr2 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega128a", "Select the atmega128a processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega128rfa1", "Select the atmega128rfa1 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega128rfr2", "Select the atmega128rfr2 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "atmega16", "Select the atmega16 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega161", "Select the atmega161 processor", { AVR::FamilyAVR3, AVR::ELFArchAVR5, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM }, { } },
  { "atmega162", "Select the atmega162 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega163", "Select the atmega163 processor", { AVR::FamilyAVR3, AVR::ELFArchAVR5, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM }, { } },
  { "atmega164a", "Select the atmega164a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega164p", "Select the atmega164p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega164pa", "Select the atmega164pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega165", "Select the atmega165 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega165a", "Select the atmega165a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega165p", "Select the atmega165p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega165pa", "Select the atmega165pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega168", "Select the atmega168 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega168a", "Select the atmega168a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega168p", "Select the atmega168p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega168pa", "Select the atmega168pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega169", "Select the atmega169 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega169a", "Select the atmega169a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega169p", "Select the atmega169p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega169pa", "Select the atmega169pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16a", "Select the atmega16a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16hva", "Select the atmega16hva processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16hva2", "Select the atmega16hva2 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16hvb", "Select the atmega16hvb processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16hvbrevb", "Select the atmega16hvbrevb processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16m1", "Select the atmega16m1 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega16u2", "Select the atmega16u2 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "atmega16u4", "Select the atmega16u4 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega2560", "Select the atmega2560 processor", { AVR::FamilyAVR6, AVR::ELFArchAVR6 }, { } },
  { "atmega2561", "Select the atmega2561 processor", { AVR::FamilyAVR6, AVR::ELFArchAVR6 }, { } },
  { "atmega2564rfr2", "Select the atmega2564rfr2 processor", { AVR::FamilyAVR6, AVR::ELFArchAVR6 }, { } },
  { "atmega256rfr2", "Select the atmega256rfr2 processor", { AVR::FamilyAVR6, AVR::ELFArchAVR6 }, { } },
  { "atmega32", "Select the atmega32 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega323", "Select the atmega323 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega324a", "Select the atmega324a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega324p", "Select the atmega324p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega324pa", "Select the atmega324pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega325", "Select the atmega325 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3250", "Select the atmega3250 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3250a", "Select the atmega3250a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3250p", "Select the atmega3250p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3250pa", "Select the atmega3250pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega325a", "Select the atmega325a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega325p", "Select the atmega325p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega325pa", "Select the atmega325pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega328", "Select the atmega328 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega328p", "Select the atmega328p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega329", "Select the atmega329 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3290", "Select the atmega3290 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3290a", "Select the atmega3290a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3290p", "Select the atmega3290p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega3290pa", "Select the atmega3290pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega329a", "Select the atmega329a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega329p", "Select the atmega329p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega329pa", "Select the atmega329pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32a", "Select the atmega32a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32c1", "Select the atmega32c1 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32hvb", "Select the atmega32hvb processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32hvbrevb", "Select the atmega32hvbrevb processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32m1", "Select the atmega32m1 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32u2", "Select the atmega32u2 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "atmega32u4", "Select the atmega32u4 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega32u6", "Select the atmega32u6 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega406", "Select the atmega406 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega48", "Select the atmega48 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega48a", "Select the atmega48a processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega48p", "Select the atmega48p processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega48pa", "Select the atmega48pa processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega64", "Select the atmega64 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega640", "Select the atmega640 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega644", "Select the atmega644 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega644a", "Select the atmega644a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega644p", "Select the atmega644p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega644pa", "Select the atmega644pa processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega644rfr2", "Select the atmega644rfr2 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega645", "Select the atmega645 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega6450", "Select the atmega6450 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega6450a", "Select the atmega6450a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega6450p", "Select the atmega6450p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega645a", "Select the atmega645a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega645p", "Select the atmega645p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega649", "Select the atmega649 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega6490", "Select the atmega6490 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega6490a", "Select the atmega6490a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega6490p", "Select the atmega6490p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega649a", "Select the atmega649a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega649p", "Select the atmega649p processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega64a", "Select the atmega64a processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega64c1", "Select the atmega64c1 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega64hve", "Select the atmega64hve processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega64m1", "Select the atmega64m1 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega64rfr2", "Select the atmega64rfr2 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "atmega8", "Select the atmega8 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega8515", "Select the atmega8515 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR4, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM }, { } },
  { "atmega8535", "Select the atmega8535 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR4, AVR::FeatureMultiplication, AVR::FeatureMOVW, AVR::FeatureLPMX, AVR::FeatureSPM }, { } },
  { "atmega88", "Select the atmega88 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega88a", "Select the atmega88a processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega88p", "Select the atmega88p processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega88pa", "Select the atmega88pa processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega8a", "Select the atmega8a processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega8hva", "Select the atmega8hva processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "atmega8u2", "Select the atmega8u2 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "attiny10", "Select the attiny10 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny102", "Select the attiny102 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny104", "Select the attiny104 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny11", "Select the attiny11 processor", { AVR::FamilyAVR1, AVR::ELFArchAVR1 }, { } },
  { "attiny12", "Select the attiny12 processor", { AVR::FamilyAVR1, AVR::ELFArchAVR1 }, { } },
  { "attiny13", "Select the attiny13 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny13a", "Select the attiny13a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny15", "Select the attiny15 processor", { AVR::FamilyAVR1, AVR::ELFArchAVR1 }, { } },
  { "attiny1634", "Select the attiny1634 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "attiny167", "Select the attiny167 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "attiny20", "Select the attiny20 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny22", "Select the attiny22 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "attiny2313", "Select the attiny2313 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny2313a", "Select the attiny2313a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny24", "Select the attiny24 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny24a", "Select the attiny24a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny25", "Select the attiny25 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny26", "Select the attiny26 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2, AVR::FeatureLPMX }, { } },
  { "attiny261", "Select the attiny261 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny261a", "Select the attiny261a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny28", "Select the attiny28 processor", { AVR::FamilyAVR1, AVR::ELFArchAVR1 }, { } },
  { "attiny4", "Select the attiny4 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny40", "Select the attiny40 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny4313", "Select the attiny4313 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny43u", "Select the attiny43u processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny44", "Select the attiny44 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny44a", "Select the attiny44a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny45", "Select the attiny45 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny461", "Select the attiny461 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny461a", "Select the attiny461a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny48", "Select the attiny48 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny5", "Select the attiny5 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "attiny828", "Select the attiny828 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny84", "Select the attiny84 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny84a", "Select the attiny84a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny85", "Select the attiny85 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny861", "Select the attiny861 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny861a", "Select the attiny861a processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny87", "Select the attiny87 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny88", "Select the attiny88 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "attiny9", "Select the attiny9 processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "atxmega128a1", "Select the atxmega128a1 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA7 }, { } },
  { "atxmega128a1u", "Select the atxmega128a1u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA7 }, { } },
  { "atxmega128a3", "Select the atxmega128a3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega128a3u", "Select the atxmega128a3u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega128a4u", "Select the atxmega128a4u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA7 }, { } },
  { "atxmega128b1", "Select the atxmega128b1 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega128b3", "Select the atxmega128b3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega128c3", "Select the atxmega128c3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega128d3", "Select the atxmega128d3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega128d4", "Select the atxmega128d4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega16a4", "Select the atxmega16a4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega16a4u", "Select the atxmega16a4u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega16c4", "Select the atxmega16c4 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega16d4", "Select the atxmega16d4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega16e5", "Select the atxmega16e5 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega192a3", "Select the atxmega192a3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega192a3u", "Select the atxmega192a3u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega192c3", "Select the atxmega192c3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega192d3", "Select the atxmega192d3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega256a3", "Select the atxmega256a3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega256a3b", "Select the atxmega256a3b processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega256a3bu", "Select the atxmega256a3bu processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega256a3u", "Select the atxmega256a3u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega256c3", "Select the atxmega256c3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega256d3", "Select the atxmega256d3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega32a4", "Select the atxmega32a4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega32a4u", "Select the atxmega32a4u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega32c4", "Select the atxmega32c4 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega32d4", "Select the atxmega32d4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega32e5", "Select the atxmega32e5 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega32x1", "Select the atxmega32x1 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "atxmega384c3", "Select the atxmega384c3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega384d3", "Select the atxmega384d3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "atxmega64a1", "Select the atxmega64a1 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA5 }, { } },
  { "atxmega64a1u", "Select the atxmega64a1u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA5 }, { } },
  { "atxmega64a3", "Select the atxmega64a3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64a3u", "Select the atxmega64a3u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64a4u", "Select the atxmega64a4u processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64b1", "Select the atxmega64b1 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64b3", "Select the atxmega64b3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64c3", "Select the atxmega64c3 processor", { AVR::FamilyXMEGAU, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64d3", "Select the atxmega64d3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega64d4", "Select the atxmega64d4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA4 }, { } },
  { "atxmega8e5", "Select the atxmega8e5 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "avr1", "Select the avr1 processor", { AVR::FamilyAVR1, AVR::ELFArchAVR1 }, { } },
  { "avr2", "Select the avr2 processor", { AVR::FamilyAVR2, AVR::ELFArchAVR2 }, { } },
  { "avr25", "Select the avr25 processor", { AVR::FamilyAVR25, AVR::ELFArchAVR25 }, { } },
  { "avr3", "Select the avr3 processor", { AVR::FamilyAVR3, AVR::ELFArchAVR3 }, { } },
  { "avr31", "Select the avr31 processor", { AVR::FamilyAVR31, AVR::ELFArchAVR31 }, { } },
  { "avr35", "Select the avr35 processor", { AVR::FamilyAVR35, AVR::ELFArchAVR35 }, { } },
  { "avr4", "Select the avr4 processor", { AVR::FamilyAVR4, AVR::ELFArchAVR4 }, { } },
  { "avr5", "Select the avr5 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
  { "avr51", "Select the avr51 processor", { AVR::FamilyAVR51, AVR::ELFArchAVR51 }, { } },
  { "avr6", "Select the avr6 processor", { AVR::FamilyAVR6, AVR::ELFArchAVR6 }, { } },
  { "avrtiny", "Select the avrtiny processor", { AVR::FamilyTiny, AVR::ELFArchTiny }, { } },
  { "avrxmega1", "Select the avrxmega1 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA1 }, { } },
  { "avrxmega2", "Select the avrxmega2 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA2 }, { } },
  { "avrxmega3", "Select the avrxmega3 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA3 }, { } },
  { "avrxmega4", "Select the avrxmega4 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA4 }, { } },
  { "avrxmega5", "Select the avrxmega5 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA5 }, { } },
  { "avrxmega6", "Select the avrxmega6 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA6 }, { } },
  { "avrxmega7", "Select the avrxmega7 processor", { AVR::FamilyXMEGA, AVR::ELFArchXMEGA7 }, { } },
  { "m3000", "Select the m3000 processor", { AVR::FamilyAVR5, AVR::ELFArchAVR5 }, { } },
};

#ifdef DBGFIELD
#error "<target>GenSubtargetInfo.inc requires a DBGFIELD macro"
#endif
#if !defined(NDEBUG) || defined(LLVM_ENABLE_DUMP)
#define DBGFIELD(x) x,
#else
#define DBGFIELD(x)
#endif

// ===============================================================
// Data tables for the new per-operand machine model.

// {ProcResourceIdx, Cycles}
extern const llvm::MCWriteProcResEntry AVRWriteProcResTable[] = {
  { 0,  0}, // Invalid
}; // AVRWriteProcResTable

// {Cycles, WriteResourceID}
extern const llvm::MCWriteLatencyEntry AVRWriteLatencyTable[] = {
  { 0,  0}, // Invalid
}; // AVRWriteLatencyTable

// {UseIdx, WriteResourceID, Cycles}
extern const llvm::MCReadAdvanceEntry AVRReadAdvanceTable[] = {
  {0,  0,  0}, // Invalid
}; // AVRReadAdvanceTable

static const llvm::MCSchedModel NoSchedModel = {
  MCSchedModel::DefaultIssueWidth,
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  MCSchedModel::DefaultLoadLatency,
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  0, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  nullptr, // No Itinerary
  nullptr // No extra processor descriptor
};

// Sorted (by key) array of itineraries for CPU subtype.
extern const llvm::SubtargetInfoKV AVRProcSchedKV[] = {
  { "at43usb320", (const void *)&NoSchedModel },
  { "at43usb355", (const void *)&NoSchedModel },
  { "at76c711", (const void *)&NoSchedModel },
  { "at86rf401", (const void *)&NoSchedModel },
  { "at90c8534", (const void *)&NoSchedModel },
  { "at90can128", (const void *)&NoSchedModel },
  { "at90can32", (const void *)&NoSchedModel },
  { "at90can64", (const void *)&NoSchedModel },
  { "at90pwm1", (const void *)&NoSchedModel },
  { "at90pwm161", (const void *)&NoSchedModel },
  { "at90pwm2", (const void *)&NoSchedModel },
  { "at90pwm216", (const void *)&NoSchedModel },
  { "at90pwm2b", (const void *)&NoSchedModel },
  { "at90pwm3", (const void *)&NoSchedModel },
  { "at90pwm316", (const void *)&NoSchedModel },
  { "at90pwm3b", (const void *)&NoSchedModel },
  { "at90pwm81", (const void *)&NoSchedModel },
  { "at90s1200", (const void *)&NoSchedModel },
  { "at90s2313", (const void *)&NoSchedModel },
  { "at90s2323", (const void *)&NoSchedModel },
  { "at90s2333", (const void *)&NoSchedModel },
  { "at90s2343", (const void *)&NoSchedModel },
  { "at90s4414", (const void *)&NoSchedModel },
  { "at90s4433", (const void *)&NoSchedModel },
  { "at90s4434", (const void *)&NoSchedModel },
  { "at90s8515", (const void *)&NoSchedModel },
  { "at90s8535", (const void *)&NoSchedModel },
  { "at90scr100", (const void *)&NoSchedModel },
  { "at90usb1286", (const void *)&NoSchedModel },
  { "at90usb1287", (const void *)&NoSchedModel },
  { "at90usb162", (const void *)&NoSchedModel },
  { "at90usb646", (const void *)&NoSchedModel },
  { "at90usb647", (const void *)&NoSchedModel },
  { "at90usb82", (const void *)&NoSchedModel },
  { "at94k", (const void *)&NoSchedModel },
  { "ata5272", (const void *)&NoSchedModel },
  { "ata5505", (const void *)&NoSchedModel },
  { "ata5790", (const void *)&NoSchedModel },
  { "ata5795", (const void *)&NoSchedModel },
  { "ata6285", (const void *)&NoSchedModel },
  { "ata6286", (const void *)&NoSchedModel },
  { "ata6289", (const void *)&NoSchedModel },
  { "atmega103", (const void *)&NoSchedModel },
  { "atmega128", (const void *)&NoSchedModel },
  { "atmega1280", (const void *)&NoSchedModel },
  { "atmega1281", (const void *)&NoSchedModel },
  { "atmega1284", (const void *)&NoSchedModel },
  { "atmega1284p", (const void *)&NoSchedModel },
  { "atmega1284rfr2", (const void *)&NoSchedModel },
  { "atmega128a", (const void *)&NoSchedModel },
  { "atmega128rfa1", (const void *)&NoSchedModel },
  { "atmega128rfr2", (const void *)&NoSchedModel },
  { "atmega16", (const void *)&NoSchedModel },
  { "atmega161", (const void *)&NoSchedModel },
  { "atmega162", (const void *)&NoSchedModel },
  { "atmega163", (const void *)&NoSchedModel },
  { "atmega164a", (const void *)&NoSchedModel },
  { "atmega164p", (const void *)&NoSchedModel },
  { "atmega164pa", (const void *)&NoSchedModel },
  { "atmega165", (const void *)&NoSchedModel },
  { "atmega165a", (const void *)&NoSchedModel },
  { "atmega165p", (const void *)&NoSchedModel },
  { "atmega165pa", (const void *)&NoSchedModel },
  { "atmega168", (const void *)&NoSchedModel },
  { "atmega168a", (const void *)&NoSchedModel },
  { "atmega168p", (const void *)&NoSchedModel },
  { "atmega168pa", (const void *)&NoSchedModel },
  { "atmega169", (const void *)&NoSchedModel },
  { "atmega169a", (const void *)&NoSchedModel },
  { "atmega169p", (const void *)&NoSchedModel },
  { "atmega169pa", (const void *)&NoSchedModel },
  { "atmega16a", (const void *)&NoSchedModel },
  { "atmega16hva", (const void *)&NoSchedModel },
  { "atmega16hva2", (const void *)&NoSchedModel },
  { "atmega16hvb", (const void *)&NoSchedModel },
  { "atmega16hvbrevb", (const void *)&NoSchedModel },
  { "atmega16m1", (const void *)&NoSchedModel },
  { "atmega16u2", (const void *)&NoSchedModel },
  { "atmega16u4", (const void *)&NoSchedModel },
  { "atmega2560", (const void *)&NoSchedModel },
  { "atmega2561", (const void *)&NoSchedModel },
  { "atmega2564rfr2", (const void *)&NoSchedModel },
  { "atmega256rfr2", (const void *)&NoSchedModel },
  { "atmega32", (const void *)&NoSchedModel },
  { "atmega323", (const void *)&NoSchedModel },
  { "atmega324a", (const void *)&NoSchedModel },
  { "atmega324p", (const void *)&NoSchedModel },
  { "atmega324pa", (const void *)&NoSchedModel },
  { "atmega325", (const void *)&NoSchedModel },
  { "atmega3250", (const void *)&NoSchedModel },
  { "atmega3250a", (const void *)&NoSchedModel },
  { "atmega3250p", (const void *)&NoSchedModel },
  { "atmega3250pa", (const void *)&NoSchedModel },
  { "atmega325a", (const void *)&NoSchedModel },
  { "atmega325p", (const void *)&NoSchedModel },
  { "atmega325pa", (const void *)&NoSchedModel },
  { "atmega328", (const void *)&NoSchedModel },
  { "atmega328p", (const void *)&NoSchedModel },
  { "atmega329", (const void *)&NoSchedModel },
  { "atmega3290", (const void *)&NoSchedModel },
  { "atmega3290a", (const void *)&NoSchedModel },
  { "atmega3290p", (const void *)&NoSchedModel },
  { "atmega3290pa", (const void *)&NoSchedModel },
  { "atmega329a", (const void *)&NoSchedModel },
  { "atmega329p", (const void *)&NoSchedModel },
  { "atmega329pa", (const void *)&NoSchedModel },
  { "atmega32a", (const void *)&NoSchedModel },
  { "atmega32c1", (const void *)&NoSchedModel },
  { "atmega32hvb", (const void *)&NoSchedModel },
  { "atmega32hvbrevb", (const void *)&NoSchedModel },
  { "atmega32m1", (const void *)&NoSchedModel },
  { "atmega32u2", (const void *)&NoSchedModel },
  { "atmega32u4", (const void *)&NoSchedModel },
  { "atmega32u6", (const void *)&NoSchedModel },
  { "atmega406", (const void *)&NoSchedModel },
  { "atmega48", (const void *)&NoSchedModel },
  { "atmega48a", (const void *)&NoSchedModel },
  { "atmega48p", (const void *)&NoSchedModel },
  { "atmega48pa", (const void *)&NoSchedModel },
  { "atmega64", (const void *)&NoSchedModel },
  { "atmega640", (const void *)&NoSchedModel },
  { "atmega644", (const void *)&NoSchedModel },
  { "atmega644a", (const void *)&NoSchedModel },
  { "atmega644p", (const void *)&NoSchedModel },
  { "atmega644pa", (const void *)&NoSchedModel },
  { "atmega644rfr2", (const void *)&NoSchedModel },
  { "atmega645", (const void *)&NoSchedModel },
  { "atmega6450", (const void *)&NoSchedModel },
  { "atmega6450a", (const void *)&NoSchedModel },
  { "atmega6450p", (const void *)&NoSchedModel },
  { "atmega645a", (const void *)&NoSchedModel },
  { "atmega645p", (const void *)&NoSchedModel },
  { "atmega649", (const void *)&NoSchedModel },
  { "atmega6490", (const void *)&NoSchedModel },
  { "atmega6490a", (const void *)&NoSchedModel },
  { "atmega6490p", (const void *)&NoSchedModel },
  { "atmega649a", (const void *)&NoSchedModel },
  { "atmega649p", (const void *)&NoSchedModel },
  { "atmega64a", (const void *)&NoSchedModel },
  { "atmega64c1", (const void *)&NoSchedModel },
  { "atmega64hve", (const void *)&NoSchedModel },
  { "atmega64m1", (const void *)&NoSchedModel },
  { "atmega64rfr2", (const void *)&NoSchedModel },
  { "atmega8", (const void *)&NoSchedModel },
  { "atmega8515", (const void *)&NoSchedModel },
  { "atmega8535", (const void *)&NoSchedModel },
  { "atmega88", (const void *)&NoSchedModel },
  { "atmega88a", (const void *)&NoSchedModel },
  { "atmega88p", (const void *)&NoSchedModel },
  { "atmega88pa", (const void *)&NoSchedModel },
  { "atmega8a", (const void *)&NoSchedModel },
  { "atmega8hva", (const void *)&NoSchedModel },
  { "atmega8u2", (const void *)&NoSchedModel },
  { "attiny10", (const void *)&NoSchedModel },
  { "attiny102", (const void *)&NoSchedModel },
  { "attiny104", (const void *)&NoSchedModel },
  { "attiny11", (const void *)&NoSchedModel },
  { "attiny12", (const void *)&NoSchedModel },
  { "attiny13", (const void *)&NoSchedModel },
  { "attiny13a", (const void *)&NoSchedModel },
  { "attiny15", (const void *)&NoSchedModel },
  { "attiny1634", (const void *)&NoSchedModel },
  { "attiny167", (const void *)&NoSchedModel },
  { "attiny20", (const void *)&NoSchedModel },
  { "attiny22", (const void *)&NoSchedModel },
  { "attiny2313", (const void *)&NoSchedModel },
  { "attiny2313a", (const void *)&NoSchedModel },
  { "attiny24", (const void *)&NoSchedModel },
  { "attiny24a", (const void *)&NoSchedModel },
  { "attiny25", (const void *)&NoSchedModel },
  { "attiny26", (const void *)&NoSchedModel },
  { "attiny261", (const void *)&NoSchedModel },
  { "attiny261a", (const void *)&NoSchedModel },
  { "attiny28", (const void *)&NoSchedModel },
  { "attiny4", (const void *)&NoSchedModel },
  { "attiny40", (const void *)&NoSchedModel },
  { "attiny4313", (const void *)&NoSchedModel },
  { "attiny43u", (const void *)&NoSchedModel },
  { "attiny44", (const void *)&NoSchedModel },
  { "attiny44a", (const void *)&NoSchedModel },
  { "attiny45", (const void *)&NoSchedModel },
  { "attiny461", (const void *)&NoSchedModel },
  { "attiny461a", (const void *)&NoSchedModel },
  { "attiny48", (const void *)&NoSchedModel },
  { "attiny5", (const void *)&NoSchedModel },
  { "attiny828", (const void *)&NoSchedModel },
  { "attiny84", (const void *)&NoSchedModel },
  { "attiny84a", (const void *)&NoSchedModel },
  { "attiny85", (const void *)&NoSchedModel },
  { "attiny861", (const void *)&NoSchedModel },
  { "attiny861a", (const void *)&NoSchedModel },
  { "attiny87", (const void *)&NoSchedModel },
  { "attiny88", (const void *)&NoSchedModel },
  { "attiny9", (const void *)&NoSchedModel },
  { "atxmega128a1", (const void *)&NoSchedModel },
  { "atxmega128a1u", (const void *)&NoSchedModel },
  { "atxmega128a3", (const void *)&NoSchedModel },
  { "atxmega128a3u", (const void *)&NoSchedModel },
  { "atxmega128a4u", (const void *)&NoSchedModel },
  { "atxmega128b1", (const void *)&NoSchedModel },
  { "atxmega128b3", (const void *)&NoSchedModel },
  { "atxmega128c3", (const void *)&NoSchedModel },
  { "atxmega128d3", (const void *)&NoSchedModel },
  { "atxmega128d4", (const void *)&NoSchedModel },
  { "atxmega16a4", (const void *)&NoSchedModel },
  { "atxmega16a4u", (const void *)&NoSchedModel },
  { "atxmega16c4", (const void *)&NoSchedModel },
  { "atxmega16d4", (const void *)&NoSchedModel },
  { "atxmega16e5", (const void *)&NoSchedModel },
  { "atxmega192a3", (const void *)&NoSchedModel },
  { "atxmega192a3u", (const void *)&NoSchedModel },
  { "atxmega192c3", (const void *)&NoSchedModel },
  { "atxmega192d3", (const void *)&NoSchedModel },
  { "atxmega256a3", (const void *)&NoSchedModel },
  { "atxmega256a3b", (const void *)&NoSchedModel },
  { "atxmega256a3bu", (const void *)&NoSchedModel },
  { "atxmega256a3u", (const void *)&NoSchedModel },
  { "atxmega256c3", (const void *)&NoSchedModel },
  { "atxmega256d3", (const void *)&NoSchedModel },
  { "atxmega32a4", (const void *)&NoSchedModel },
  { "atxmega32a4u", (const void *)&NoSchedModel },
  { "atxmega32c4", (const void *)&NoSchedModel },
  { "atxmega32d4", (const void *)&NoSchedModel },
  { "atxmega32e5", (const void *)&NoSchedModel },
  { "atxmega32x1", (const void *)&NoSchedModel },
  { "atxmega384c3", (const void *)&NoSchedModel },
  { "atxmega384d3", (const void *)&NoSchedModel },
  { "atxmega64a1", (const void *)&NoSchedModel },
  { "atxmega64a1u", (const void *)&NoSchedModel },
  { "atxmega64a3", (const void *)&NoSchedModel },
  { "atxmega64a3u", (const void *)&NoSchedModel },
  { "atxmega64a4u", (const void *)&NoSchedModel },
  { "atxmega64b1", (const void *)&NoSchedModel },
  { "atxmega64b3", (const void *)&NoSchedModel },
  { "atxmega64c3", (const void *)&NoSchedModel },
  { "atxmega64d3", (const void *)&NoSchedModel },
  { "atxmega64d4", (const void *)&NoSchedModel },
  { "atxmega8e5", (const void *)&NoSchedModel },
  { "avr1", (const void *)&NoSchedModel },
  { "avr2", (const void *)&NoSchedModel },
  { "avr25", (const void *)&NoSchedModel },
  { "avr3", (const void *)&NoSchedModel },
  { "avr31", (const void *)&NoSchedModel },
  { "avr35", (const void *)&NoSchedModel },
  { "avr4", (const void *)&NoSchedModel },
  { "avr5", (const void *)&NoSchedModel },
  { "avr51", (const void *)&NoSchedModel },
  { "avr6", (const void *)&NoSchedModel },
  { "avrtiny", (const void *)&NoSchedModel },
  { "avrxmega1", (const void *)&NoSchedModel },
  { "avrxmega2", (const void *)&NoSchedModel },
  { "avrxmega3", (const void *)&NoSchedModel },
  { "avrxmega4", (const void *)&NoSchedModel },
  { "avrxmega5", (const void *)&NoSchedModel },
  { "avrxmega6", (const void *)&NoSchedModel },
  { "avrxmega7", (const void *)&NoSchedModel },
  { "m3000", (const void *)&NoSchedModel },
};

#undef DBGFIELD
namespace AVR_MC {
unsigned resolveVariantSchedClassImpl(unsigned SchedClass,
    const MCInst *MI, unsigned CPUID) {
  // Don't know how to resolve this scheduling class.
  return 0;
}
} // end of namespace AVR_MC

struct AVRGenMCSubtargetInfo : public MCSubtargetInfo {
  AVRGenMCSubtargetInfo(const Triple &TT, 
    StringRef CPU, StringRef FS, ArrayRef<SubtargetFeatureKV> PF,
    ArrayRef<SubtargetFeatureKV> PD,
    const SubtargetInfoKV *ProcSched,
    const MCWriteProcResEntry *WPR,
    const MCWriteLatencyEntry *WL,
    const MCReadAdvanceEntry *RA, const InstrStage *IS,
    const unsigned *OC, const unsigned *FP) :
      MCSubtargetInfo(TT, CPU, FS, PF, PD, ProcSched,
                      WPR, WL, RA, IS, OC, FP) { }

  unsigned resolveVariantSchedClass(unsigned SchedClass,
      const MCInst *MI, unsigned CPUID) const override {
    return AVR_MC::resolveVariantSchedClassImpl(SchedClass, MI, CPUID); 
  }
};

static inline MCSubtargetInfo *createAVRMCSubtargetInfoImpl(const Triple &TT, StringRef CPU, StringRef FS) {
  return new AVRGenMCSubtargetInfo(TT, CPU, FS, AVRFeatureKV, AVRSubTypeKV, 
                      AVRProcSchedKV, AVRWriteProcResTable, AVRWriteLatencyTable, AVRReadAdvanceTable, 
                      nullptr, nullptr, nullptr);
}

} // end namespace llvm

#endif // GET_SUBTARGETINFO_MC_DESC


#ifdef GET_SUBTARGETINFO_TARGET_DESC
#undef GET_SUBTARGETINFO_TARGET_DESC

#include "llvm/Support/Debug.h"
#include "llvm/Support/raw_ostream.h"

// ParseSubtargetFeatures - Parses features string setting specified
// subtarget options.
void llvm::AVRSubtarget::ParseSubtargetFeatures(StringRef CPU, StringRef FS) {
  LLVM_DEBUG(dbgs() << "\nFeatures:" << FS);
  LLVM_DEBUG(dbgs() << "\nCPU:" << CPU << "\n\n");
  InitMCProcessorInfo(CPU, FS);
  const FeatureBitset& Bits = getFeatureBits();
  if (Bits[AVR::ELFArchAVR1] && ELFArch < ELF::EF_AVR_ARCH_AVR1) ELFArch = ELF::EF_AVR_ARCH_AVR1;
  if (Bits[AVR::ELFArchAVR2] && ELFArch < ELF::EF_AVR_ARCH_AVR2) ELFArch = ELF::EF_AVR_ARCH_AVR2;
  if (Bits[AVR::ELFArchAVR3] && ELFArch < ELF::EF_AVR_ARCH_AVR3) ELFArch = ELF::EF_AVR_ARCH_AVR3;
  if (Bits[AVR::ELFArchAVR4] && ELFArch < ELF::EF_AVR_ARCH_AVR4) ELFArch = ELF::EF_AVR_ARCH_AVR4;
  if (Bits[AVR::ELFArchAVR5] && ELFArch < ELF::EF_AVR_ARCH_AVR5) ELFArch = ELF::EF_AVR_ARCH_AVR5;
  if (Bits[AVR::ELFArchAVR6] && ELFArch < ELF::EF_AVR_ARCH_AVR6) ELFArch = ELF::EF_AVR_ARCH_AVR6;
  if (Bits[AVR::ELFArchAVR25] && ELFArch < ELF::EF_AVR_ARCH_AVR25) ELFArch = ELF::EF_AVR_ARCH_AVR25;
  if (Bits[AVR::ELFArchAVR31] && ELFArch < ELF::EF_AVR_ARCH_AVR31) ELFArch = ELF::EF_AVR_ARCH_AVR31;
  if (Bits[AVR::ELFArchAVR35] && ELFArch < ELF::EF_AVR_ARCH_AVR35) ELFArch = ELF::EF_AVR_ARCH_AVR35;
  if (Bits[AVR::ELFArchAVR51] && ELFArch < ELF::EF_AVR_ARCH_AVR51) ELFArch = ELF::EF_AVR_ARCH_AVR51;
  if (Bits[AVR::ELFArchTiny] && ELFArch < ELF::EF_AVR_ARCH_AVRTINY) ELFArch = ELF::EF_AVR_ARCH_AVRTINY;
  if (Bits[AVR::ELFArchXMEGA1] && ELFArch < ELF::EF_AVR_ARCH_XMEGA1) ELFArch = ELF::EF_AVR_ARCH_XMEGA1;
  if (Bits[AVR::ELFArchXMEGA2] && ELFArch < ELF::EF_AVR_ARCH_XMEGA2) ELFArch = ELF::EF_AVR_ARCH_XMEGA2;
  if (Bits[AVR::ELFArchXMEGA3] && ELFArch < ELF::EF_AVR_ARCH_XMEGA3) ELFArch = ELF::EF_AVR_ARCH_XMEGA3;
  if (Bits[AVR::ELFArchXMEGA4] && ELFArch < ELF::EF_AVR_ARCH_XMEGA4) ELFArch = ELF::EF_AVR_ARCH_XMEGA4;
  if (Bits[AVR::ELFArchXMEGA5] && ELFArch < ELF::EF_AVR_ARCH_XMEGA5) ELFArch = ELF::EF_AVR_ARCH_XMEGA5;
  if (Bits[AVR::ELFArchXMEGA6] && ELFArch < ELF::EF_AVR_ARCH_XMEGA6) ELFArch = ELF::EF_AVR_ARCH_XMEGA6;
  if (Bits[AVR::ELFArchXMEGA7] && ELFArch < ELF::EF_AVR_ARCH_XMEGA7) ELFArch = ELF::EF_AVR_ARCH_XMEGA7;
  if (Bits[AVR::FamilyAVR0]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR1]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR2]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR3]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR4]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR5]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR6]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR25]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR31]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR35]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyAVR51]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyTiny]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyXMEGA]) m_FeatureSetDummy = true;
  if (Bits[AVR::FamilyXMEGAU]) m_FeatureSetDummy = true;
  if (Bits[AVR::FeatureADDSUBIW]) m_hasADDSUBIW = true;
  if (Bits[AVR::FeatureBREAK]) m_hasBREAK = true;
  if (Bits[AVR::FeatureDES]) m_hasDES = true;
  if (Bits[AVR::FeatureEIJMPCALL]) m_hasEIJMPCALL = true;
  if (Bits[AVR::FeatureELPM]) m_hasELPM = true;
  if (Bits[AVR::FeatureELPMX]) m_hasELPMX = true;
  if (Bits[AVR::FeatureIJMPCALL]) m_hasIJMPCALL = true;
  if (Bits[AVR::FeatureJMPCALL]) m_hasJMPCALL = true;
  if (Bits[AVR::FeatureLPM]) m_hasLPM = true;
  if (Bits[AVR::FeatureLPMX]) m_hasLPMX = true;
  if (Bits[AVR::FeatureMOVW]) m_hasMOVW = true;
  if (Bits[AVR::FeatureMultiplication]) m_supportsMultiplication = true;
  if (Bits[AVR::FeatureRMW]) m_supportsRMW = true;
  if (Bits[AVR::FeatureSPM]) m_hasSPM = true;
  if (Bits[AVR::FeatureSPMX]) m_hasSPMX = true;
  if (Bits[AVR::FeatureSRAM]) m_hasSRAM = true;
  if (Bits[AVR::FeatureSetSpecial]) m_FeatureSetDummy = true;
  if (Bits[AVR::FeatureSmallStack]) m_hasSmallStack = true;
  if (Bits[AVR::FeatureTinyEncoding]) m_hasTinyEncoding = true;
}
#endif // GET_SUBTARGETINFO_TARGET_DESC


#ifdef GET_SUBTARGETINFO_HEADER
#undef GET_SUBTARGETINFO_HEADER

namespace llvm {
class DFAPacketizer;
namespace AVR_MC {
unsigned resolveVariantSchedClassImpl(unsigned SchedClass, const MCInst *MI, unsigned CPUID);
}

struct AVRGenSubtargetInfo : public TargetSubtargetInfo {
  explicit AVRGenSubtargetInfo(const Triple &TT, StringRef CPU, StringRef FS);
public:
  unsigned resolveSchedClass(unsigned SchedClass,  const MachineInstr *DefMI, const TargetSchedModel *SchedModel) const override;
  unsigned resolveVariantSchedClass(unsigned SchedClass, const MCInst *MI, unsigned CPUID) const override;
  DFAPacketizer *createDFAPacketizer(const InstrItineraryData *IID) const;
};
} // end namespace llvm

#endif // GET_SUBTARGETINFO_HEADER


#ifdef GET_SUBTARGETINFO_CTOR
#undef GET_SUBTARGETINFO_CTOR

#include "llvm/CodeGen/TargetSchedule.h"

namespace llvm {
extern const llvm::SubtargetFeatureKV AVRFeatureKV[];
extern const llvm::SubtargetFeatureKV AVRSubTypeKV[];
extern const llvm::SubtargetInfoKV AVRProcSchedKV[];
extern const llvm::MCWriteProcResEntry AVRWriteProcResTable[];
extern const llvm::MCWriteLatencyEntry AVRWriteLatencyTable[];
extern const llvm::MCReadAdvanceEntry AVRReadAdvanceTable[];
AVRGenSubtargetInfo::AVRGenSubtargetInfo(const Triple &TT, StringRef CPU, StringRef FS)
  : TargetSubtargetInfo(TT, CPU, FS, makeArrayRef(AVRFeatureKV, 33), makeArrayRef(AVRSubTypeKV, 257), 
                        AVRProcSchedKV, AVRWriteProcResTable, AVRWriteLatencyTable, AVRReadAdvanceTable, 
                        nullptr, nullptr, nullptr) {}

unsigned AVRGenSubtargetInfo
::resolveSchedClass(unsigned SchedClass, const MachineInstr *MI, const TargetSchedModel *SchedModel) const {
  report_fatal_error("Expected a variant SchedClass");
} // AVRGenSubtargetInfo::resolveSchedClass

unsigned AVRGenSubtargetInfo
::resolveVariantSchedClass(unsigned SchedClass, const MCInst *MI, unsigned CPUID) const {
  return AVR_MC::resolveVariantSchedClassImpl(SchedClass, MI, CPUID);
} // AVRGenSubtargetInfo::resolveVariantSchedClass
} // end namespace llvm

#endif // GET_SUBTARGETINFO_CTOR

